import 'dart:async';

// In order to *not* need this ignore, consider extracting the "web" version
// of your plugin as a separate package, instead of inlining it in the same
// package as the core of your plugin.
// ignore: avoid_web_libraries_in_flutter

import 'package:flutter_web_plugins/flutter_web_plugins.dart';
import 'package:mixpanel_plus_interface/mixpanel_plus_interface.dart';
import 'web/mixpanel_js_bindings.dart' as js;

/// A web implementation of the MixpanelPlusWeb plugin.
class MixpanelPlusPlugin extends MixpanelPlusPlatform {
  static void registerWith(Registrar registrar) {
    MixpanelPlusPlatform.instance = MixpanelPlusPlugin();
  }

  @override
  void alias(String alias, String distinctId) {
    js.alias(alias, distinctId);
  }

  @override
  void clearSuperProperties() {
    // TODO: implement clearSuperProperties
  }

  @override
  Future<double?> eventElapsedTime(String eventName) {
    // TODO: implement eventElapsedTime
    throw UnimplementedError();
  }

  @override
  void flush() {
    // TODO: implement flush
  }

  @override
  Future<String?> getDistinctId() {
    // TODO: implement getDistinctId
    throw UnimplementedError();
  }

  @override
  Future<Map?> getSuperProperties() {
    // TODO: implement getSuperProperties
    throw UnimplementedError();
  }

  @override
  Future<bool?> hasOptedOutTracking() {
    // TODO: implement hasOptedOutTracking
    throw UnimplementedError();
  }

  @override
  void identify(String distinctId) {
    js.identify(distinctId);
  }

  @override
  Future<MixpanelPlusPlatform> init(String token,
      {bool optOutTrackingDefault = false}) {
    js.init(token);

    return Future.value(MixpanelPlusPlugin());
  }

  @override
  void optInTracking() {
    // TODO: implement optInTracking
  }

  @override
  void optOutTracking() {
    // TODO: implement optOutTracking
  }

  @override
  void registerSuperProperties(Map<String, dynamic> properties) {
    js.register(properties);
  }

  @override
  void registerSuperPropertiesOnce(Map<String, dynamic> properties) {
    // TODO: implement registerSuperPropertiesOnce
  }

  @override
  void reset() {
    // TODO: implement reset
  }

  @override
  void setLoggingEnabled(bool loggingEnabled) {
    // TODO: implement setLoggingEnabled
  }

  @override
  void setServerURL(String serverURL) {
    // TODO: implement setServerURL
  }

  @override
  void setUseIpAddressForGeolocation(bool useIpAddressForGeolocation) {
    // TODO: implement setUseIpAddressForGeolocation
  }

  @override
  void timeEvent(String eventName) {
    // TODO: implement timeEvent
  }

  @override
  void track(String eventName, {Map<String, dynamic>? properties}) {
    js.track(eventName, properties ?? {});
  }

  @override
  void unregisterSuperProperty(String propertyName) {
    // TODO: implement unregisterSuperProperty
  }
}
